<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL$
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Author(s): Zack Bartel <bartel@osuosl.org>                             |
// +------------------------------------------------------------------------+
// $Id: RangeAvailableIPsDataList.php 3985 2005-12-20 22:53:35Z bartel $
require_once($phphtmllib."/widgets/data_list/ArrayDataListSource.inc");

class RangeAvailableIPsDataList extends DefaultGUIDataList
{
//{{{   vars
    var $_range;
    var $_subnet;
    var $_default_rows_per_page = 100;
//}}}
//{{{  get_data_source()
    /**
     *  This function sets up the data source for the data list.
     *  In this case we are using a ArrayDataListSource rather
     *  than a DB_DataObjectDataSource (as in most cases with Maintain)
     *  because the data is a list of IP Addresses that do not have a
     *  DBDO representation.
     *
     */
     
    function get_data_source()
    {
        $this->_range = new Range($_REQUEST['id']);

        if (!$this->_subnet)    {
            $this->_subnet = new Subnet($this->_range->subnet);
        }

        $source = new ArrayDataListSource($this->_range->get_free_addresses());
        /*10 isn't enough here */
        $this->set_data_source(&$source);
    }
//}}}
//{{{   user_setup()
    /**
     *  This function sets up the table columns for the datalist 
     *  and sets attributes.
     *
     */
    function user_setup()
    {
        $this->add_header_item(_("IP Address"), "20%");
        $this->add_header_item(_("Subnet"), "20%");
        $this->add_header_item(_("Netmask"), "20%");
    }
//}}}
//{{{   build_column_item()
    /**
     *  This function decides how the data will appear per row
     *  and data.
     *  
     *  @param  array   $row_data   the current row to build for
     *  @param  string  $col_name   the current column to build for
     *
     *
     *  @return Object  $obj        the custom rendering for the given data
     *
     */
    function build_column_item($row_data, $col_name)
    {
        switch($col_name)   {   
            
        case _('IP Address'):
            $obj = IP::int2ip($row_data);
            break;
        case _('Subnet'):
            //$obj = $_range->getSubnet();
            $obj = $this->_subnet->getSubnet();
            break;
        case _('Netmask'):
            $obj = $this->_subnet->getNetmask();
            break;
        default:
            break;        
        }
        return $obj;
    }
//}}}
}

?>
