<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL: https://svn.osuosl.org/public/maintain2/branches/2.6/class/htdocs/forms/HostDisplayForm.php $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Author(s): Michael Clay <claym@osuosl.org>                             |
// |            Zack Bartel <bartel@osuosl.org>                             |
// |            Frederic Wenzel <fred@osuosl.org>                           |
// +------------------------------------------------------------------------+
// $Id: HostCreateForm.php 3966 2005-12-12 15:32:02Z bartel $

/**
 *  HostCreateForm.php - contains the {@link HostDisplayForm}
 *                   
 *
 *  @author $Author: bartel $
 *  @filesource
 *  @package    htdocs
 *  @subpackage forms
 */

define("DYNAMIC", 0);
define("STATICIP",1);

require_once(FORMDIR."/MaintainForm.php");

/**
 *  This is the form for editing hosts.
 *
 *  @package    htdocs
 *  @subpackage forms
 */
class HostCreateForm extends MaintainForm
{

//{{{   vars

    /**
     *  This var is an array that maps the form labels to the DBDO backend
     *  variables.  Relationship is form label => dbdo var.
     */
    var $map = array("Hostname"     =>"name",
                    "Domain"        =>"domain",
                    "HW_Address"    =>"ha",
                    "Dynamic_Range" =>"dynamic_range",
                    "IP_Address"    =>"ip",
                    "Workgroup"     =>"workgroup",
                    "Status"        =>"enabled",
                    "Other_ID"      =>"other_id",
                    "Host_TTL"      =>"ttl",
                    "Operating_System" => "os",
                    "Expire_Date"   =>"expire",
                    "Location"      =>"location",
                    "Serial_Number" =>"serial",
                    "PO_Number"     =>"po_number",
                    "Warranty_Date"  =>"warranty_date",
                    "User_ID"       =>"user_id",
                    "Owning_Unit"   =>"owning_unit",
                    "Purchase_Date" =>"purchase_date"
                    );
      var $java;

//}}}

/*Form Content Method Overloading*/
//{{{   form_init_elements()

    /**
     *  This method makes the elements for the form.
     */
    function form_init_elements()
    {
        global $user, $id;
        
        $hostname = new FEText(_('Hostname'),true);
        $domain = new FEListBox(_("Domain"));
        
        //ipaddy
        //Ip address select from range
        $drorip = new FERadioGroup(_("Type"),array("Dynamic"=>"dynamic", "Static"=>"static"));
        $ip = new FEText(_('IP Address'), false);
        $dr = new FEListBox(_('Dynamic Range'), false);
        // enable and disable the static and dynamic ip fields respectively on click
        $js = "var thisform = document.".$this->get_form_name().";"
            ."var dr = thisform.".$dr->get_element_name().";"
            ."var ip = thisform.".$ip->get_element_name().";"
            ."if (thisform."._("Type")."[1].checked) { dr.disabled = true; ip.disabled = false; dr.value = '';"
            ."} else {"
            ."dr.disabled = false; ip.disabled = true; ip.value = '';}";
            
        /*
         *  Javascript to disable the appropriate fields on run.
         *  This sets window.onload (the javascript function to run when the page loads)
         *  to the function run(), which is defined below. run() calls the function
         *  disable(ob) twice, once for each radio button (Type_1 and Type_0).
         *  disable(ob) first checks to see if the object is rendered, if it is then it
         *  checks the radio buttons, and disables the correct field, along with resetting
         *  the value of the disabled box.  If the object is not rendered, it calls
         *  setTimeout(vCode, iMilliSeconds) that waits 5 milliseconds then calls disable
         *  again with the same object until it is rendered.
         */
        $this->java = "window.onload = run(); " //set load action to run()
                 ."function run() { " //runs disable on Type_0 and Type_1
                 ."disable(\""._("Type")."_0\"); "
                 ."disable(\""._("Type")."_1\"); "
                 ."} "
                 ."function disable(ob) { " //define disable
                 ."if(document.getElementById(ob)) { " //it doesn't work if it's not rendered yet
                 ."var thisform = document.".$this->get_form_name()."; "
                 ."var dr = thisform.".$dr->get_element_name()."; "
                 ."var ip = thisform.".$ip->get_element_name()."; "
                 ."if(thisform."._("Type")."[1].checked) {" //check which button is checked
                 ."dr.disabled = true; ip.disabled = false; dr.value = 0; "
                 ."} else if(thisform."._("Type")."[0].checked) { "
                 ."dr.disabled = false; ip.disabled = true; ip.value = ''; "
                 ."} else { "
                 ."dr.disabled = true; ip.disabled = true; ip.value = ''; dr.value = 0; "
                 ."} "
                 ."} else { " //otherwise it's not rendered yet
                 ."setTimeout(\"disable('\" + ob + \"')\", 5); " //wait 5ms, and run disable(ob)
                 ."} "
                 ."}";
                 
        $drorip->set_Onclick($js);
        $dr->set_list_data($this->_ranges());
        
        $ha = new FEText(_('HW Address'),true);
        $workgroup = new FEListBox(_("Workgroup"));
        $workgroup->set_required(false);
       
        $status = new FEListBox(_("Status"));
        $comment = new FETextArea(_("Comment"),true, 3,40);

        /*Init the list boxes!*/
        $domain->set_list_data($this->_domains());
        $workgroup->set_list_data($this->_workgroups());
        $status->set_list_data(array(_("Disabled")=>0, _("Enabled")=>1));
        $ttl = new FEText(_("Host TTL"), true);
        $expire = new FEText(_("Expire Date"));


        $this->add_elements($hostname, $domain, $ha, $drorip, $dr, $ip, $ttl, $status, $workgroup, $expire);
        
        /* if we're in "advanced" viewing OR we are creating a new host */
        if(!strcasecmp($_REQUEST['view'], "advanced") || 
            (!isset($_REQUEST['view']) && 
            !strcasecmp($user->host_view,"advanced")) ) {
           
            /*
            $ary = array(new FEText("Test") => 0);
            $os = new FERadioGroup(_("Operating System"), $ary);
            */
            $os = new FEText(_("Operating System"), false);
            $loc = new FEText(_("Location"));
            $sn = new FEText(_("Serial Number"));
            $purch = new FEText(_("Purchase Date"));
            $ponum = new FEText(_("PO Number"));
            $warranty = new FEText(_("Warranty Date"));

            $own = new FEText(_("Owning Unit"));
            $otherid = new FEText(_("Other ID"));
            $userid = new FEText(_("User ID"));
            
            $this->add_elements($os, $loc, $sn, $purch, $ponum, $warranty,
                                $own, $otherid, $userid);
        }

        $this->add_element($comment);
        $this->set_action($_SERVER["SCRIPT_NAME"]);
    }

//}}}
//{{{   form_init_data()

    /**
     *  This method sets the inital values for all the fun forms
     */

    function form_init_data()
    {
/*        global $id;

        $host = new Host($_REQUEST['id']);

        $array = $host->toArray();

        $init = $this->remap($array,FORM);
        $init['Domain'] = $host->domain; //one special case
        $init['Workgroup'] = $host->workgroup; //two special cases
        /* 
        foreach($init as $label=>$val) {
            if($this->contains_element($label)) {
                $this->set_element_value($label,$val);
            }
        }
*/      global $conf; 

        $wg = DB_DataObject::Factory("workgroup");
        $wg->name = $conf['general']['default_workgroup'];
        $res = $wg->find();

        $ip =& $this->get_element(_("IP Address"));
        $ip->set_disabled(true);
        $dr =& $this->get_element(_("Dynamic Range"));
        $dr->set_disabled(true);

        $this->set_element_value(_("Comment"),"Host Created");
        $this->set_element_value(_("Host TTL"), $conf['soa']['default_host_ttl']);
        if($res === true)
            $this->set_element_value(_("Workgroup"),$conf['general']['default_workgroup']);
        else
            $this->set_element_value(_("Workgroup"),"");
    }    

//}}}
//{{{   form()

    /**
     *  This method lays the form out
     *
     *  @return DIVTag  $div    Div that contains the form
    function form()
    {
        $div = html_div("createform");
        $table = html_table();
        $class = array(0=>"even",
                        1=>"odd");
        $temp = 1;
        foreach($this->_elements as $label=>$element) {
            $tr = html_tr($class[++$temp%2]);
            $tr->add($this->element_label($label));
            $tr->add($this->element_form($label));
            $table->add($tr);
        }
        
        $this->add_element(new FEHidden("action", "create"));
        $this->add_element(new FEHidden("id", $id));
        
        $tr = html_tr($class[++$temp%2]);
        $tr->add(_HTML_SPACE,container($this->add_action(_("Create")), 
                                        $this->add_action(_("Cancel"))));
        $table->add_row($tr);
        $div->add($table);
        $div->add($this->element_form("action"));
        $div->add($this->element_form("id"));
        return $div;
    }

     */
//}}}
//{{{   form_action()

    function form_action()
    {
        global $user;

        $res = false;
        switch($this->get_action())
        {
            case _("Submit"): //Create button got pressed
                $host = new Host();
                $host->query("BEGIN");  
               //$vals = $this->remap($this->get_all_element_values(), DBDO);
                $vals = $this->remap($_POST, DBDO);
                //Lets set the hosts values to the submitted ones.
                $host->setFrom($vals);
                $host->setZone($_SESSION['zone']);
                $host->last_seen = time();                

                $valid = $host->insert(); //attempt to insert


                if($valid === false) { //If validation failed due to error
                    $host->query("ROLLBACK");
                    $this->add_error(_("ERROR"),_("Failed to create host!")); 

                }
                else { //otherwise life is good
                    $host->query("COMMIT");
                    //Make a record of the event
                    $host->write_history($_REQUEST[_('Comment')], ACTION_CREATE, $user->username, $host->zone);
                    $res = true;
                }
             
                break;
            case _("Cancel"):
                $res = true;
                header("Location: host.php?action=show");
                break;
            default:
                $this->add_error(_("ERROR"),_("Unrecognized action"));
                $res = false;
                break;
        }
        
        return $res;
    }

//}}}
//{{{   form_success()

    /**
     *  This method is executed when the form_action method returns true.
     *  In this case it redirects the user to the host edit page with the new vals.
     */
    function form_success()
    {
        $div = html_div("success");
        $indlink = html_a(web_root()."index.php", _("[Return to Index]"));
        $hostlink = html_a(web_root()."host.php", _("[Return to Host List]"));
        $div->add(_("Host Successfully Updated"), html_br(), $indlink, $hostlink);
        return $div;
    }


//}}}
//{{{   form_backend_validation()

    /**
     *  This method is the one that performs the validation using a the DBDO's
     *  built in authentication methods.  It takes advantage of the remap function
     *  in order to maintain a relationship between the internal vars of the DBDO
     *  and the form values()
     *
     *  @return boolean $res    True if validation successful
     */
    function form_backend_validation()
    {
        $host = new Host(); //make a host
        $array = $this->get_all_element_values(); // get the form values
        $host->setFrom($this->remap($array,DBDO)); //give them to the host
        $host->setZone($_SESSION['zone']);
        $valid = $host->validate(); //validate the host with new info
        
        $res = true; //assume true

        //Special case for IP/Ranges
        if($array[_("Type")] == _("static") && 
        ($array[_("IP_Address")] == "" || $array[_("IP_Address")] == NULL)) { //if it's static and there is no IP
            $this->add_error(_("IP Address"),_("A static host must have an IP")); //add error
            $res = false; //not valid IP
        }

        if($array[_("Type")] == _("dynamic") &&  $array[_("Dynamic_Range")] == NULL) {
            $this->add_error(_("Dynamic Range"),_("A dynamic host must be assigned a dynamic range")); //add error
            $res = false;    
        }

        //Comment block is a special case
        $comvalid = validate_comment($array[_("Comment")]);
        if($comvalid !== true) { //if the comment isn't valid
            $this->add_error(_("Comment"),$comvalid); //add error
            $res = false; //not valid form
        }

        //everything else
        if(is_array($valid)) {
            $errors = $this->remap($valid, FORM); //Remap the errors to forms
            foreach($errors as $name=>$state)
                if($state !== true && $state != NULL)   {
                    //true or null (DB_DataObject) implies that part was valid
                    $res = false; //result is not valid form
                    $this->add_error($name,$state); //add an error
                }
       }
        return $res; //we're done
    }

//}}}

//{{{ javascript()
//writes the javascript in <script> tags
function javascript()
{
    return $this->java;
}
//}}}

/*Helper Methods to generate arrays to populate the list boxes*/
//{{{   _domains()

    /**
     *  This method is a helper method that is here really jsut to clean up the
     *  code.  This method gets an array of domain ids indexed by their names.
     *  It is meant to populate the list boxes.
     *
     *  @return Array $domains  An array of domain ids indexed by name
     */
    function _domains()
    {
        global $user;
        
        $domains = array();
       
        //The fun part about this is zone_domain doesn't know the name...
        //Thus we do a magical join operation because the domain table does.
        $zd = DB_DataObject::Factory('zone_domain');
        if(!$user->is_admin())//If they're a full admin we don't care about zones
            $zd->zone = $_SESSION['zone'];
        $dom = DB_DataObject::Factory('domain');
        $dom->joinAdd($zd);
        $dom->orderBy('name');

        $dom->find();

        while($dom->fetch()) {
            $domains[$dom->name] = $dom->domain;
        }

        return $domains;
    }

//}}}
//{{{   _workgroups()

    /**
     *  This method gets the workgroups that are eligible targets for moving a
     *  host to.  The result is an array of workgroup names that are indexed by
     *  their database id.  This method is only to clean up code appearance.
     *
     *  @return Array   $workgroups  An array of workgroup ids indexed  by name.
     */
    function _workgroups()
    {
        global $user, $conf;

        $host = new Host($_REQUEST['id']);
        $workgroups = array();
        
        $workgroups[""] = ""; //add blank if they don't really want the thing.
        
        $zw = DB_DataObject::Factory('zone_workgroup');
        $zw->zone = $host->zone; 
        $wg = DB_DataObject::Factory('workgroup');
        $wg->joinAdd($zw);
        $wg->orderBy('name');

        $wg->find();

        while($wg->fetch()) {
            $workgroups[$wg->name] = $wg->workgroup;
        }

/*
        $wg = DB_DataObject::Factory('workgroup');
        $wg->name = $conf['general']['default_workgroup'];
        $wg->find(1);
        $workgroups[$wg->name] = $wg->id;
*/
        return $workgroups;
    }

//}}}
//{{{ _ranges()

    function _ranges()
    {
        global $zone;
        
        $res = array();
        
        $zr = DB_DataObject::Factory('zone_range');
        $zr->zone = $zone;
        $range = new Range();
        $range->type  = "dynamic";
        $range->joinAdd($zr);
        $range->find();

        $res[""] = NULL; //for static IP
        
        while($range->fetch()) {
            $start = $range->start;
            settype($start, "double");
            $start = long2ip($start);

            $end = $range->end;
            settype($end, "double");
            $end = long2ip($end);
            $type = ($range->type =='static'?'S':'D');
            
            $res["($type) ".$range->name.", (".$start._(" to ").$end.")"] = $range->range;
        }
        
        return $res;
    }

//}}}

}

?>
