<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL: https://svn.osuosl.org/public/maintain-project/branches/maintain-3/htdocs/pointer.php $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Authors: Michael Clay <claym@osuosl.org>                               |
// |          Zack Bartel  <bartel@osuosl.org>                              |
// +------------------------------------------------------------------------+
// $Id: pointer.php 4758 2006-08-18 21:37:02Z schonstal $

/**
  * DNS Pointer Pages
  *
  * @pacakge    htdocs
  */

require_once("includes.php");
require_once(HTCLASS."/datalist/PointerDataList.php");
require_once(FORMDIR."/PointerCreateForm.php");
require_once(FORMDIR."/MaintainDeleteConfirm.php");
require_once(FORMDIR."/PointerEditForm.php");
require_once(FORMDIR."/ObjectMoveZoneForm.php");


session_start();

setup_user_environment();

$title = html_span("title");

$skin = Skin::Factory($user->color_template);

$content = container($title);

global $user;

switch(strtolower($_REQUEST['action'])) {

case 'enable':
case 'disable':
case 'edit':
    if(!$user->is_zone_user($zone))
        header("Location: denied.php");

    $title->add(_("Modifying Pointer"));
    $content->add($title);
    $content->add(html_br(2),Skin::amFactory(AM_EDIT,_("Pointer")),html_br(2));
    $content->add(show_live_time($_REQUEST['id'],_("Pointer")));
    $pef = new FormProcessor(new PointerEditForm, "pointeredit");
    $pef->set_render_form_after_success(false);
    
    $move = new FormProcessor(new ObjectMoveZoneForm('pointer'), 'moveptr');
    $move->set_render_form_after_success(false);

    if (!$move->is_action_successfull())
        $content->add($pef);
        
    if (!$pef->is_action_successfull() && $user->is_zone_admin($_REQUEST['Target_Zone']) 
                                       && $user->is_zone_admin($_SESSION['zone']))
        $content->add($move);
    break;
    
case 'create':
    if(!$user->is_zone_admin($zone))
        header("Location: denied.php");
    $title->add(_("Creating New Pointer"));
    $content->add($title);
    $pcf = new FormProcessor(new PointerCreateForm(),"pointercreate");
    $pcf->set_render_form_after_success(false);
    $content->add($pcf);
    break;

case 'delconfirm':
case 'delete':
    if(!$user->is_zone_admin($zone))
        header("Location: denied.php");
    $title->add(_("Delete Pointer"));
    $content->add($title);
    $delconfirm = new FormProcessor(new MaintainDeleteConfirm("Pointer","Hostname"), 
                                                            "delconfirm");
    $delconfirm->set_render_form_after_success(false);
    $content->add($delconfirm);
    break;

case 'show':

default:
    if(isset($_REQUEST['id'])) {
        $title->add(_("Viewing Pointer"));
        $content->add($title);
        $content->add(html_br(2), Skin::amFactory(AM_SHOW,_("Pointer")),html_br(2));
        $content->add(show_live_time($_REQUEST['id'],_("Pointer")));
        $pointer = new Pointer($_REQUEST['id']);
        $content = Module::apply_filter("object_info",$content,$pointer); 
    }
    else {
        $title->add(_("Viewing Pointers"));
        $content->add($title);
        $content->add(html_br(2),Skin::amFactory(AM_LIST,_("Pointer")),html_br(2));
        $pl = new PointerDataList("Pointers");
        $pl->user_setup();
        $content->add($pl);
    }   
}

print $skin->display($content);

?>
